//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Vevar8.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#include <math.h>
#include <stdio.h>

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

////////////////////////
///                  ///
/// P R O G R A M I  ///
///                  ///
////////////////////////

// Izraun koeficientov transformacijske matrike
// Podamo koeficiente C (a, b, c) (koordinate toke, iz katere gledamo na predmet)
// Oddaljenost zaslona = d

double V[4][4];
double pi = 3.141592;

// etrti faktor vsake toke in pomeni skaliranje objekta
double q = 1;

// Deklaracija vtopnih tok kocke
double k[12][4];

// Deklaracija matrike za premik KS
double pr[4][4];

// Deklaracija za vstopne konstante
double alfa, beta, d, G;

// Premik koordinatnega sistema
double pr1, pr2, pr3;

// pomoni koeficient
double f=1;


void Transformacijska_matrika (double alfa, double beta, double d, double G)
{
V[0][0]= - sin(alfa * pi /180);
V[0][1]= - cos(alfa * pi /180)*cos(beta * pi /180);
V[0][2]= -cos(alfa * pi /180)*sin(beta * pi /180);
V[0][3]= 0;
V[1][0]= cos(alfa * pi /180);
V[1][1]= -sin(alfa * pi /180)*cos(beta * pi /180);
V[1][2]= -sin(alfa * pi /180)*sin(beta * pi /180);
V[1][3]= 0;
V[2][0]= 0;
V[2][1]= sin(beta*pi/180);
V[2][2]= -cos(beta*pi/180);
V[2][3]= 0;
V[3][0]= 0;
V[3][1]= 0;
V[3][2]= G;
V[3][3]= 1;

}

// Izris rte med dvema podanima tokama
// Podane so koordinate toke X1, Y1, X2, Y2
// Kot rezultat dobimo izrisano rto

void Izris_Crte (double x1, double y1, double x2, double y2)
    {
    //Form1->Image1->Canvas->Pen->Color = clYellow;
    Form1->Image1->Canvas->MoveTo(x1,y1);
    Form1->Image1->Canvas->LineTo(x2,y2);
    }



//------------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{

/////////////////////////////////////////////
//Izraun ravnine iz treh tok na ravnini //
///////////////////////////////////////////

// Branje tok obeh ravnin
double TO[6][3];

TO[0][0]=Edit7->Text.ToDouble();
TO[0][1]=Edit9->Text.ToDouble();
TO[0][2]=Edit10->Text.ToDouble();
TO[1][0]=Edit11->Text.ToDouble();
TO[1][1]=Edit12->Text.ToDouble();
TO[1][2]=Edit13->Text.ToDouble();
TO[2][0]=Edit14->Text.ToDouble();
TO[2][1]=Edit15->Text.ToDouble();
TO[2][2]=Edit16->Text.ToDouble();
TO[3][0]=Edit17->Text.ToDouble();
TO[3][1]=Edit18->Text.ToDouble();
TO[3][2]=Edit19->Text.ToDouble();
TO[4][0]=Edit20->Text.ToDouble();
TO[4][1]=Edit21->Text.ToDouble();
TO[4][2]=Edit22->Text.ToDouble();
TO[5][0]=Edit23->Text.ToDouble();
TO[5][1]=Edit24->Text.ToDouble();
TO[5][2]=Edit25->Text.ToDouble();

// Izraun koeficientov obeh ravnin (Ax + By + Cz + D = 0)

double A1, A2, B1, B2, C1, C2, D1, D2;

A1 = (TO[1][1]-TO[0][1])*(TO[2][2]-TO[0][2])-(TO[1][2]-TO[0][2])*(TO[2][1]-TO[0][1]);
B1 = (TO[1][2]-TO[0][2])*(TO[2][0]-TO[0][0])-(TO[1][0]-TO[0][0])*(TO[2][2]-TO[0][2]);
C1 = (TO[1][0]-TO[0][0])*(TO[2][1]-TO[0][1])-(TO[1][1]-TO[0][1])*(TO[2][0]-TO[0][0]);
D1 = -(TO[0][0]*A1+TO[0][1]*B1+TO[0][2]*C1);
A2 = (TO[4][1]-TO[3][1])*(TO[5][2]-TO[3][2])-(TO[4][2]-TO[3][2])*(TO[5][1]-TO[3][1]);
B2 = (TO[4][2]-TO[3][2])*(TO[5][0]-TO[3][0])-(TO[4][0]-TO[3][0])*(TO[5][2]-TO[3][2]);
C2 = (TO[4][0]-TO[3][0])*(TO[5][1]-TO[3][1])-(TO[4][1]-TO[3][1])*(TO[5][0]-TO[3][0]);
D2 = -(TO[3][0]*A2+TO[3][1]*B2+TO[3][2]*C2);

// Izraun smernega vektorja presene premice n1 X n2 = s2;
// n1 = (A1, B1, C1)
// n2 = (A2, B2, C2)

double s[3];

s[0] = B1*C2-C1*B2;
s[1] = A2*C1-A1*C2;
s[2] = A1*B2-A2*B1;

// Na premici iemo najblijo toko koordinatnemu izhodiu
// Izberemo poljubno toko na premici, katero prestavimo nato v najblijo
// toko koordinatnemu izhodiu. Poljubno toko izraunamo iz obeh ravnin

double KR[6];

KR[2]=0;
KR[1]=(D1*A2-D2*A1)/(-B1*A2+B2*A1);
KR[0]=(D1*B2-D2*B1)/(B1*A2-B2*A1);

// Izraun toke, ki je najblija koordinatnemu izhodiu
// t = faktor, ki nam pove velikost koraka po premici, da pridemo v eljeno toko

double t;

t = -(KR[0]*s[0]+KR[1]*s[1]+KR[2]*s[2])/(s[0]*s[0]+s[1]*s[1]+s[2]*s[2]);
KR[3] = KR[0] + t * s[0];
KR[4] = KR[1] + t * s[1];
KR[5] = KR[2] + t * s[2];

// Izraun najkraje razdalje od premice do izhodia koordinatnega sistema

double L;
L=sqrt(KR[3]*KR[3]+KR[4]*KR[4]+KR[5]*KR[5]);

if (L>=200)
{
L = L;
}
else
{
L = 200;
}

// Doloitev robnih tok na premici za doloitev pravokotnika ravnine
// polovico irine pravolkotnika vzamemo da je L

double t0, t3;

t0 = L/(s[0]*s[0]+s[1]*s[1]+s[2]*s[2]);
k[0][0]=KR[3]+t0*s[0];
k[0][1]=KR[4]+t0*s[1];
k[0][2]=KR[5]+t0*s[2];
k[0][3]=1;
k[1][0]=KR[3]-t0*s[0];
k[1][1]=KR[4]-t0*s[1];
k[1][2]=KR[5]-t0*s[2];
k[1][3]=1;


//Izraun konnih tok za preseno premico
//Tukaj podamo nekoliko vejo dolino premice in vzamemo kar 3L na obe strani

t3 = 3*L/(s[0]*s[0]+s[1]*s[1]+s[2]*s[2]);
k[10][0]=KR[3]+t3*s[0];
k[10][1]=KR[4]+t3*s[1];
k[10][2]=KR[5]+t3*s[2];
k[10][3]=1;
k[11][0]=KR[3]-t3*s[0];
k[11][1]=KR[4]-t3*s[1];
k[11][2]=KR[5]-t3*s[2];
k[11][3]=1;


// Doloitev smernih vektorjev za izraun ogljinih tok r1 in r2

double r[6];
r[0]=B1*s[2]-C1*s[1];   // Ravnina 1
r[1]=C1*s[0]-A1*s[2];
r[2]=A1*s[1]-B1*s[0];
r[3]=B2*s[2]-C2*s[1];   // Ravnina 2
r[4]=C2*s[0]-A2*s[2];
r[5]=A2*s[1]-B2*s[0];

double t1, t2;
t1= 10*L/(r[0]*r[0]+r[1]*r[1]+r[2]*r[2]);
t2= 5*L/(r[3]*r[3]+r[4]*r[4]+r[5]*r[5]);

k[2][0]=k[0][0]+t1*r[0];  //Oglia za ravnino 1
k[2][1]=k[0][1]+t1*r[1];
k[2][2]=k[0][2]+t1*r[2];
k[2][3]=1;
k[3][0]=k[0][0]-t1*r[0];
k[3][1]=k[0][1]-t1*r[1];
k[3][2]=k[0][2]-t1*r[2];
k[3][3]=1;
k[4][0]=k[1][0]+t1*r[0];
k[4][1]=k[1][1]+t1*r[1];
k[4][2]=k[1][2]+t1*r[2];
k[4][3]=1;
k[5][0]=k[1][0]-t1*r[0];
k[5][1]=k[1][1]-t1*r[1];
k[5][2]=k[1][2]-t1*r[2];
k[5][3]=1;

k[6][0]=k[0][0]+t2*r[3];  //Oglia za ravnino 2
k[6][1]=k[0][1]+t2*r[4];
k[6][2]=k[0][2]+t2*r[5];
k[6][3]=1;
k[7][0]=k[0][0]-t2*r[3];
k[7][1]=k[0][1]-t2*r[4];
k[7][2]=k[0][2]-t2*r[5];
k[7][3]=1;
k[8][0]=k[1][0]+t2*r[3];
k[8][1]=k[1][1]+t2*r[4];
k[8][2]=k[1][2]+t2*r[5];
k[8][3]=1;
k[9][0]=k[1][0]-t2*r[3];
k[9][1]=k[1][1]-t2*r[4];
k[9][2]=k[1][2]-t2*r[5];
k[9][3]=1;

// dobimo podatke C (a, b, c)
// Oddaljenost zaslona od gledia = d
// Kota zasuka od osi x in z

if (f == 1)
{
alfa = -60;
beta = 60;
d = 200;
G = 300;
pr1 = 100;
pr2 = -250;
pr3 = 50;

}
f++;


// Transformacija tok

Transformacijska_matrika (alfa, beta, d, G);

int i = 0;
while (i <= 11)
{
int j = 0;
    while (j <=  3)
    {
    k[i][j]=k[i][0]*V[0][j]+k[i][1]*V[1][j]+k[i][2]*V[2][j]+k[i][3]*V[3][j];
    j++;
    }
    i=i+1;
}

// Transformacija tok v pogledno ravnino oddaljeno za razdaljo = d

i = 0;
while (i<=11)
{
int j=0;
    while (j<=1)
    {
    k[i][j]=k[i][j]/(k[i][2]/d);
    j++;
    }
i++;
}

//                               DODATEK

i = 0;
while (i<=11)
{
int j=0;
    while (j<=2)
    {
    k[i][j]=k[i][j]*100;
    j++;
    }
i++;
}





// Izraun premika koordinatnega sistema
// Podamo za koliko se kam premaknemo

// Preberemo velikost premika


pr[0][0] = 1;
pr[0][1] = 0;
pr[0][2] = 0;
pr[0][3] = 0;
pr[1][0] = 0;
pr[1][1] = 1;
pr[1][2] = 0;
pr[1][3] = 0;
pr[2][0] = 0;
pr[2][1] = 0;
pr[2][2] = 1;
pr[2][3] = 0;
pr[3][0] = pr1;
pr[3][1] = pr2;
pr[3][2] = pr3;
pr[3][3] = 1;


//Mnoenje tok z to matriko za premik koordinatnega sistema


 i = 0;
while (i <= 11)
{
int j = 0;
    while (j <=  3)
    {
    k[i][j]=k[i][0]*pr[0][j]+k[i][1]*pr[1][j]+k[i][2]*pr[2][j]+k[i][3]*pr[3][j];
    j++;
    }
    i=i+1;
}

// transformacija osi Y

i = 0;
while (i<=11)
{
k[i][1]=k[i][1]*(-1);
i++;
}


// Izris ravnin

Form1->Image1->Canvas->FillRect(Form1->Image1->ClientRect);

Form1->Image1->Canvas->Pen->Color = clRed;
Izris_Crte (k[10][0], k[10][1], k[11][0], k[11][1]);

Form1->Image1->Canvas->Pen->Color = clBlue;
Izris_Crte (k[2][0], k[2][1], k[3][0], k[3][1]);
Izris_Crte (k[3][0], k[3][1], k[5][0], k[5][1]);
Izris_Crte (k[5][0], k[5][1], k[4][0], k[4][1]);
Izris_Crte (k[4][0], k[4][1], k[2][0], k[2][1]);

Form1->Image1->Canvas->Pen->Color = clPurple;
Izris_Crte (k[6][0], k[6][1], k[7][0], k[7][1]);
Izris_Crte (k[7][0], k[7][1], k[9][0], k[9][1]);
Izris_Crte (k[9][0], k[9][1], k[8][0], k[8][1]);
Izris_Crte (k[8][0], k[8][1], k[6][0], k[6][1]);


// Podaja koordinat za izraun koordinatnega sistama

double ks[4][4];
ks[0][0] = 0;    // nika KS
ks[0][1] = 0;
ks[0][2] = 0;
ks[0][3] = 1;
ks[1][0] = 500;  // X os KS
ks[1][1] = 0;
ks[1][2] = 0;
ks[1][3] = 1;
ks[2][0] = 0;    // Y os KS
ks[2][1] = 500;
ks[2][2] = 0;
ks[2][3] = 1;
ks[3][0] = 0;    // Z os KS
ks[3][1] = 0;
ks[3][2] = 500;
ks[3][3] = 1;


// transformacija v pogledne koordinate

 i = 0;
while (i <= 3)
{
int j = 0;
    while (j <= 3)
    {
    ks[i][j]=ks[i][0]*V[0][j]+ks[i][1]*V[1][j]+ks[i][2]*V[2][j]+ks[i][3]*V[3][j];
    j++;
    }
    i=i+1;
}


// Premik koordinatnega sistema
 i = 0;
while (i <= 3)
{
int j = 0;
    while (j <= 3)
    {
    ks[i][j]=ks[i][0]*pr[0][j]+ks[i][1]*pr[1][j]+ks[i][2]*pr[2][j]+ks[i][3]*pr[3][j];
    j++;
    }
    i=i+1;
}

// transformacija osi Y

i = 0;
while (i<=3)
{
ks[i][1]=ks[i][1]*(-1);
i++;
}


// Izris koordinatnega sistema

Form1->Image1->Canvas->Pen->Color = clBlack;
Izris_Crte (ks[0][0], ks[0][1], ks[1][0], ks[1][1]);
Form1->Image1->Canvas->Pen->Color = clBlack;
Izris_Crte (ks[0][0], ks[0][1], ks[2][0], ks[2][1]);
Form1->Image1->Canvas->Pen->Color = clLime;
Izris_Crte (ks[0][0], ks[0][1], ks[3][0], ks[3][1]);



}
//--------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
alfa = alfa + 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
alfa = alfa - 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
beta = beta + 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
beta = beta - 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
d = d + 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
d = d - 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
pr1 = pr1 + 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
pr1 = pr1 - 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
pr2 = pr2 + 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
pr2 = pr2 - 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
G =G + 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
G =G - 10;
Button1Click(Sender);
}
//---------------------------------------------------------------------------







